#include<bits/stdc++.h>
#define ll long long
using namespace std;
bool Resenje(vector<ll> a,int k)
{
    int aura=0;
    for(int i=0;i<a.size();i++)
    {
       if(a[i]>=aura)
       {
           aura++;
       }
       else{
           aura--;
       }
    }
    return aura==k;
}
int main()
{
    int t,n,k;
    vector<ll> a,b;
    cin>>t>>n>>k;
    for(int i=0;i<n;i++)
    {
        ll x;
        cin>>x;
        a.push_back(x);
    }
    sort(a.begin(),a.end());
    if(Resenje(a,k)){
        cout<<"DA"<<endl;
        for(int i=0;i<a.size();i++)
        {
            cout<<a[i]<<" ";
        }
    }
    else{
        cout<<"NE"<<endl;
    }




}